diff --git a/lib/librte_pmd_enic/ReleaseNotes.txt b/lib/librte_pmd_enic/ReleaseNotes.txt
new file mode 100644
index 0000000..9d9ef3b
--- /dev/null
+++ b/lib/librte_pmd_enic/ReleaseNotes.txt
@@ -0,0 +1,196 @@
+================================================================================
+         DPDK Poll-mode Driver for Cisco Systems Inc. VIC Ethernet NIC
+                                 Release Notes
+                                Version 1.0.0.3
+================================================================================
+  ENIC PMD is the poll-mode driver for the Cisco System Inc. VIC Ethernet NIC
+  to be used with DPDK suite.
+
+  If you are running/would like to run your applications on Intel DPDK software 
+  suite on Cisco UCS servers that use Cisco VIC adapters, please read the 
+  information provided in this document.
+
+How to obtain ENIC PMD integrated DPDK?
+---------------------------------------
+  The source tarball of the whole DPDK suite, dpdk-<version>.tar.gz could be 
+  downloaded from www.dpdk.org
+
+  Alternatively, the same could be downloaded from www.cisco.com.  
+
+
+Software License
+----------------
+  Please read the file LICENSE in lib/librte_pmd_enic/ directory in DPDK 
+  source tree.
+
+  The License terms are also present at the top of the source files.
+
+
+Configuration information
+-------------------------
+  In order to ensure that ENIC PMD will also be built by DPDK build scripts, 
+  ensure that CONFIG_RTE_LIBRTE_ENIC_PMD=y is there in the following file in 
+  DPDK suite.
+
+  - config/common_linuxapp
+
+  If CONFIG_RTE_EAL_VFIO is y in config/common/linuxapp in the DPDK source
+  tree, ENIC PMD will try to get initialized using VFIO.  If
+  CONFIG_RTE_EAL_VFIO is n, it will try to use UIO framework.
+
+  No matter how many receive/transmit queues are configured in the service
+  profile, only one interrupt per vNIC interface needs to be configured.
+  ENIC PMD uses this interrupt to get information about errors in the fast path.
+
+
+How to build the suite?
+-----------------------
+  The build instruction of DPDK suite should be followed and that would build
+  ENIC PMD library as well.
+
+  Typically, a user would execute the following commands to build the suite
+   - tar -xzf dpdk-<version>.tar.gz
+   - cd dpdk-<version>
+   - make install T=x86_64-native-linuxapp-gcc
+
+
+Version Information
+-------------------
+  The version of ENIC driver will be printed by ENIC PMD during the 
+  intialization.
+
+  This release notes is a part of version number 1.0.0.3
+
+Directory Structure
+-------------------
+librte_pmd_enic
+|-- LICENSE
+|      License terms
+|
+|-- Makefile
+|      Makefile to build ENIC PMD as a part of building DPDK
+|
+|-- scripts
+|   |-- bind_to_vfio
+|   |       Script which binds a vNIC to VFIO
+|   |
+|   `-- unbind_from_vfio
+|           Script which unbinds a vNIC from VFIO
+|
+`-- src
+       Source code of ENIC PMD
+
+
+Dependencies
+------------
+ - If the user wants to use DPDK with VFIO, the Linux kernel used 
+   should have support for Linux VFIO.  Linux kernels post 3.6.0 supports VFIO
+
+   The header file vfio.h should be present in /usr/include/linux/
+
+   For kernels post 3.6.0, this file should be present in 
+   <kernel_src_dir>/usr/include/linux/
+
+   In the case of Ubuntu, if the file is not present, install the 
+   package linux_libc_dev
+
+ - This version of ENIC PMD has been tested with DPDK suite version 1.7.1
+
+ - For using UIO framework, please refer the documentation that comes with
+   DPDK suite
+
+
+Supported Cisco VIC adapters 
+----------------------------
+ - ENIC PMD could be used with all the generations of Cisco VIC adapters.
+ - Flow director feature is not supported on generation 1 Cisco VIC adapters
+   (M81KR and P81E)
+
+
+Supported Operating Systems
+---------------------------
+Any Linux distribution fulfilling the conditions described in Dependencies 
+section of this document.
+
+Supported features in this release
+------------------------------------
+ - Unicast, multicast and broadcast transmission and reception
+ - Receive queue polling
+ - Statistics
+ - Hardware VLAN acceleration
+ - IP checksum offload
+ - Receive side header-split
+ - Receive side VLAN stripping
+ - Multiple receive and transmit queues
+ - Perfect filters for flow direction (supported on all adapters except M81KR
+   and P81E)
+ - Promiscuous mode
+ - Setting RX VLAN (supported via UCSM/CIMC only)
+ - VLAN filtering (supported via UCSM/CIMC only)
+ - Execution of application by unprivileged system users
+ 
+
+Known bugs and Unsupported features in this release
+---------------------------------------------------
+ - Signature filters
+ - Drop feature of perfect filters
+ - VLAN based flow direction
+ - Flexbytes based flow direction
+ - Setting of extended VLAN
+
+
+Prerequisites
+-------------
+ - Prepare the system as recommended by DPDK suite.  This includes environment
+   variables, hugepages configuration, tool-chains and configuration
+ - Insert vfio-pci kernel module using the command 'modprobe vfio-pci' if the
+   user wants to use VFIO framework
+ - Insert uio kernel module using the command 'modprobe uio' if the user wants
+   to use UIO framework
+ - DPDK suite should be configured based on the user's decision to use VFIO or
+   UIO framework
+ - Bind the intended vNIC to vfio-pci using librte_pmd_enic/scripts/bind_to_vfio
+   in case the user wants ENIC PMD to use VFIO framework
+ - Bind the intended vNIC to igb_uio in case the user wants ENIC PMD to use
+   UIO framework
+
+ Now, the system is ready to run the application.  Once the application runs to 
+ completion, if it is required, the vNIC could be detached from vfio-pci or igb_uio.
+ vNICs could be detached from vfio-pci using the script
+ librte_pmd_enic/scripts/unbind_from_vfio
+
+ Root privilege is required to bind and unbind vNICs to/from VFIO/UIO.
+
+ VFIO framework helps an unprivileged user to run the applications.
+
+ For an unprivileged user to run the applications on DPDK and ENIC PMD,
+ it might be required to increase the maximum locked memory of the user.
+ The following command could be used to do this.
+
+ sudo sh -c "ulimit -l <value in Kilo Bytes>"
+
+ The value depends on the memory configuration of the application, DPDK and
+ PMD.  Typically, the limit has to be raised to higher than 2GB. 
+ e.g., 2621440
+
+ The compilation of any unused drivers could be turned off using the
+ configuration file in config/ directory (e.g., config/common_linuxapp).  
+ This would help in bringing down the time taken for building the 
+ libraries and the initialization time of the application.  
+
+Additional Reference
+--------------------
+ - www.dpdk.org
+ - Intel® Data Plane Development Kit: Release Notes
+ - Intel® Data Plane Development Kit: Programmer's Guide
+ - Intel® Data Plane Development Kit Testpmd Application: Guide
+
+
+Contact Information
+-------------------
+  Any questions or bugs should be reported to DPDK community or to the following
+  email addresses.
+
+  Sujith Sankar <ssujith@cisco.com>
+  Prasad Rao <prrao@cisco.com>
+